/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by lister-gen. DO NOT EDIT.

package v1beta2

import (
	v1beta2 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_aws/aws/v1beta2"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// AWSManagedClusterLister helps list AWSManagedClusters.
// All objects returned here must be treated as read-only.
type AWSManagedClusterLister interface {
	// List lists all AWSManagedClusters in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta2.AWSManagedCluster, err error)
	// AWSManagedClusters returns an object that can list and get AWSManagedClusters.
	AWSManagedClusters(namespace string) AWSManagedClusterNamespaceLister
	AWSManagedClusterListerExpansion
}

// aWSManagedClusterLister implements the AWSManagedClusterLister interface.
type aWSManagedClusterLister struct {
	indexer cache.Indexer
}

// NewAWSManagedClusterLister returns a new AWSManagedClusterLister.
func NewAWSManagedClusterLister(indexer cache.Indexer) AWSManagedClusterLister {
	return &aWSManagedClusterLister{indexer: indexer}
}

// List lists all AWSManagedClusters in the indexer.
func (s *aWSManagedClusterLister) List(selector labels.Selector) (ret []*v1beta2.AWSManagedCluster, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta2.AWSManagedCluster))
	})
	return ret, err
}

// AWSManagedClusters returns an object that can list and get AWSManagedClusters.
func (s *aWSManagedClusterLister) AWSManagedClusters(namespace string) AWSManagedClusterNamespaceLister {
	return aWSManagedClusterNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// AWSManagedClusterNamespaceLister helps list and get AWSManagedClusters.
// All objects returned here must be treated as read-only.
type AWSManagedClusterNamespaceLister interface {
	// List lists all AWSManagedClusters in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta2.AWSManagedCluster, err error)
	// Get retrieves the AWSManagedCluster from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1beta2.AWSManagedCluster, error)
	AWSManagedClusterNamespaceListerExpansion
}

// aWSManagedClusterNamespaceLister implements the AWSManagedClusterNamespaceLister
// interface.
type aWSManagedClusterNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all AWSManagedClusters in the indexer for a given namespace.
func (s aWSManagedClusterNamespaceLister) List(selector labels.Selector) (ret []*v1beta2.AWSManagedCluster, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta2.AWSManagedCluster))
	})
	return ret, err
}

// Get retrieves the AWSManagedCluster from the indexer for a given namespace and name.
func (s aWSManagedClusterNamespaceLister) Get(name string) (*v1beta2.AWSManagedCluster, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1beta2.Resource("awsmanagedcluster"), name)
	}
	return obj.(*v1beta2.AWSManagedCluster), nil
}
